# All files / src SourceMapCorrector.ts

100% Statements 20/20
100% Branches 7/7
100% Functions 1/1
100% Lines 19/19

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    841x
    1x

    1x

    1x

    1x

    1816x
    1816x

    1816x

    1816x
    1804x

    12x

    12x

    3x

    3x

    9x
    3x

    6x

    6x

    9x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from './container/ServiceIdentifiers';

    import { TObfuscationResultFactory } from './types/container/TObfuscationResultFactory';

    import { IObfuscationResult } from './interfaces/IObfuscationResult';
    import { IOptions } from './interfaces/options/IOptions';
    import { ISourceMapCorrector } from './interfaces/ISourceMapCorrector';

    import { SourceMapMode } from './enums/SourceMapMode';

    import { CryptUtils } from './utils/CryptUtils';

    @injectable()
    export class SourceMapCorrector implements ISourceMapCorrector {
        /**
         * @type {TObfuscationResultFactory}
         */
        private readonly obfuscationResultFactory: TObfuscationResultFactory;

        /**
         * @type {IOptions}
         */
        private readonly options: IOptions;

        /**
         * @param obfuscationResultFactory
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers['Factory<IObfuscationResult>']) obfuscationResultFactory: TObfuscationResultFactory,
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            this.obfuscationResultFactory = obfuscationResultFactory;
            this.options = options;
        }

        /**
         * @returns {ObfuscationResult}
         * @param obfuscatedCode
         * @param sourceMap
         */
        public correct (obfuscatedCode: string, sourceMap: string): IObfuscationResult {
            return this.obfuscationResultFactory(
                this.correctObfuscatedCode(obfuscatedCode, sourceMap),
                sourceMap
            );
        }

        /**
         * @param obfuscatedCode
         * @param sourceMap
         * @returns {string}
         */
        private correctObfuscatedCode (obfuscatedCode: string, sourceMap: string): string {
            if (!sourceMap) {
                return obfuscatedCode;
            }

            const sourceMapUrl: string = this.options.sourceMapBaseUrl + this.options.sourceMapFileName;

            let sourceMappingUrl: string = '//# sourceMappingURL=';

            switch (this.options.sourceMapMode) {
                case SourceMapMode.Inline:
                    sourceMappingUrl += `data:application/json;base64,${CryptUtils.btoa(sourceMap)}`;

                    break;

                case SourceMapMode.Separate:
                default:
                    if (!sourceMapUrl) {
                        return obfuscatedCode;
                    }

                    sourceMappingUrl += sourceMapUrl;

                    break;
            }

            return `${obfuscatedCode}\n${sourceMappingUrl}`;
        };
    }